﻿-- Addon: QuestTranslator (wersja: 70300.05) 2017.09.01
-- Opis: AddOn wyświetla przetłumaczone questy.
-- Autor: Platine  (e-mail: platine.wow@gmail.com)
-- Addon project page: http://qtr.top.098.pl

-- Zmienne globalne
      QTR_version = GetAddOnMetadata("QuestTranslator", "Version");
local QTR_name = UnitName("player");
local QTR_class= UnitClass("player");
local QTR_race = UnitRace("player");
local QTR_waitTable = {};
local QTR_waitFrame = nil;
local QuestTranslator_MessOrig = {
      details    = "Description", 
      objectives = "Objectives", 
      rewards    = "Rewards", 
      itemchoose1= "You will be able to choose one of these rewards:", 
      itemchoose2= "Choose one of these rewards:", 
      itemreceiv1= "You will also receive:", 
      itemreceiv2= "You receiving the reward:", 
      learnspell = "Learn Spell:", 
      reqmoney   = "Required Money:", 
      reqitems   = "Required items:", 
      experience = "Experience:", 
      currquests = "Current Quests", 
      avaiquests = "Available Quests", };
local QTR_quest_EN = {
      id = 0,
      title = "",
      details = "",
      objectives = "",
      progress = "",
      completion = "",
      itemchoose = "",
      itemreceive = "", };      
local QTR_quest_LG = {
      id = 0,
      title = "",
      details = "",
      objectives = "",
      progress = "",
      completion = "",
      itemchoose = "",
      itemreceive = "", };      
local QTR_Reklama = {
      ON = "Reklamuj dodatek na czacie kanału nr:",
      PERIOD= "Okres czasu pomiędzy kolejnymi reklamami:",
      CHOICE= "Który tekst wyświetlać? (gdy zaznaczysz oba, to naprzemian):",
      OTHER1= "tłumacz w dodatku QuestGuru ",
      OTHER2= "tłumacz w dodatku Immersion ",
      ACTIV1= "(aktywny)",
      ACTIV2= "(nieaktywny)",
      TEXT1 = "QuestTranslator - addon that displays the translated quests (www.qtr.top.098.pl)",
      TEXT2 = "QuestTranslator - dodatek wyświetlający przetłumaczone questy (www.qtr.top.098.pl)", };
local last_time = GetTime();
local last_text = 0;
local curr_trans = "1";
local Original_Font1 = "Fonts\\MORPHEUS.ttf";
local Original_Font2 = "Fonts\\FRIZQT__.ttf";
local p_race = {
      ["Blood Elf"] = { M = "Krwawy Elf", W = "krwawy elfie", D = "krwawego elfa", N = "krwawym elfem" },
      ["Draenei"] = { M = "Draenei", W = "draeneiu", D = "draeneia", N = "draeneiem" },
      ["Dwarf"] = { M = "Krasnolud", W = "krasnoludzie", D = "krasnoluda", N = "krasnoludem" },
      ["Gnome"] = { M = "Gnom", W = "gnomie", D = "gnoma", N = "gnomem" },
      ["Goblin"] = { M = "Goblin", W = "goblinie", D = "goblina", N = "goblinem" },
      ["Human"] = { M = "Człowiek", W = "człowieku", D = "człowieka", N = "człowiekiem" },
      ["Night Elf"] = { M = "Nocny Elf", W = "nocny elfie", D = "nocnego elfa", N = "nocnym elfem" },
      ["Orc"] = { M = "Ork", W = "orku", D = "orka", N = "orkiem" },
      ["Pandaren"] = { M = "Panderan", W = "panderanie", D = "panderana", N = "panderanem" },
      ["Tauren"] = { M = "Tauren", W = "taurenie", D = "taurena", N = "taurenem" },
      ["Troll"] = { M = "Troll", W = "trollu", D = "trolla", N = "trollem" },
      ["Undead"] = { M = "Nieumarły", W = "nieumarły", D = "nieumarłego", N = "nieumarłym" },
      ["Worgen"] = { M = "Worgen", W = "worgenie", D = "worgena", N = "worgenem" }, }
local p_class = {
      ["Death Knight"] = { M = "Rycerz Śmierci", W = "rycerzu śmierci", B = "rycerza śmierci", N = "rycerzem śmierci" },
      ["Demon Hunter"] = { M = "Łowca demonów", W = "łowco demonów", B = "łowcę demonów", N = "łowcą demonów" },
      ["Druid"] = { M = "Driud", W = "druidzie", B = "druida", N = "druidem" },
      ["Hunter"] = { M = "Łowca", W = "łowco", B = "łowcę", N = "łowcą" },
      ["Mage"] = { M = "Czarodziej", W = "czarodzieju", B = "czarodzieja", N = "czarodziejem" },
      ["Monk"] = { M = "Mnich", W = "Mnichu", B = "mnicha", N = "mnichem" },
      ["Paladin"] = { M = "Paladyn", W = "paladynie", B = "paladyna", N = "paladynem" },
      ["Priest"] = { M = "Kapłan", W = "kapłanie", B = "kapłana", N = "kapłanem" },
      ["Rogue"] = { M = "Łotrzyk", W = "łotrzyku", B = "łotrzyka", N = "łotrzykiem" },
      ["Shaman"] = { M = "Szaman", W = "szamanie", B = "szamana", N = "szamanem" },
      ["Warlock"] = { M = "Czarnoksiężnik", W = "czarnoksiężniku", B = "czarnoksiężnika", N = "czarnoksiężnikiem" },
      ["Warrior"] = { M = "Wojownik", W = "wojowniku", B = "wojownika", N = "wojownikiem" }, }
 player_race = { M = p_race[QTR_race].M, W = p_race[QTR_race].W, D = p_race[QTR_race].D, N = p_race[QTR_race].N };
 player_class = { M = p_class[QTR_class].M, W = p_class[QTR_class].W, B = p_class[QTR_class].B, N = p_class[QTR_class].N };


-- Pierwsza funkcja wywoływana po załadowaniu dodatku
function QTR_OnLoad()
   QTR = CreateFrame("Frame");
   QTR:SetScript("OnEvent", QTR_OnEvent);
   QTR:RegisterEvent("ADDON_LOADED");
   QTR:RegisterEvent("QUEST_ACCEPTED");
   QTR:RegisterEvent("QUEST_DETAIL");
   QTR:RegisterEvent("QUEST_PROGRESS");
   QTR:RegisterEvent("QUEST_COMPLETE");

   -- przycisk z nr ID questu w QuestFrame
   QTR_ToggleButton0 = CreateFrame("Button",nil, QuestFrame, "UIPanelButtonTemplate");
   QTR_ToggleButton0:SetWidth(150);
   QTR_ToggleButton0:SetHeight(20);
   QTR_ToggleButton0:SetText("Quest ID=?");
   QTR_ToggleButton0:Show();
   QTR_ToggleButton0:ClearAllPoints();
   QTR_ToggleButton0:SetPoint("TOPLEFT", QuestFrame, "TOPLEFT", 92, -25);
   QTR_ToggleButton0:SetScript("OnClick", QTR_ON_OFF);
   
   -- przycisk z nr ID questu w QuestLogPoputDetailFrame
   QTR_ToggleButton1 = CreateFrame("Button",nil, QuestLogPopupDetailFrame, "UIPanelButtonTemplate");
   QTR_ToggleButton1:SetWidth(150);
   QTR_ToggleButton1:SetHeight(20);
   QTR_ToggleButton1:SetText("Quest ID=?");
   QTR_ToggleButton1:Show();
   QTR_ToggleButton1:ClearAllPoints();
   QTR_ToggleButton1:SetPoint("TOPLEFT", QuestLogPopupDetailFrame, "TOPLEFT", 40, -31);
   QTR_ToggleButton1:SetScript("OnClick", QTR_ON_OFF);

   -- przycisk z nr ID questu w QuestMapDetailsScrollFrame
   QTR_ToggleButton2 = CreateFrame("Button",nil, QuestMapDetailsScrollFrame, "UIPanelButtonTemplate");
   QTR_ToggleButton2:SetWidth(150);
   QTR_ToggleButton2:SetHeight(20);
   QTR_ToggleButton2:SetText("Quest ID=?");
   QTR_ToggleButton2:Show();
   QTR_ToggleButton2:ClearAllPoints();
   QTR_ToggleButton2:SetPoint("TOPLEFT", QuestMapDetailsScrollFrame, "TOPLEFT", 116, 29);
   QTR_ToggleButton2:SetScript("OnClick", QTR_ON_OFF);

   -- funkcja wywoływana po kliknięciu na nazwę questu w QuestTracker   
   hooksecurefunc(QUEST_TRACKER_MODULE, "OnBlockHeaderClick", QTR_QuestLogOpen);
   
   -- funkcja wywoływana po kliknięciu na nazwę questu w QuestMapFrame
   hooksecurefunc("QuestMapFrame_ShowQuestDetails", QTR_QuestLogOpen);
   
   if (QuestGuru ~= nil ) then
      -- przycisk z nr ID questu w QuestGuru
      QTR_ToggleButton3 = CreateFrame("Button",nil, QuestGuru, "UIPanelButtonTemplate");
      QTR_ToggleButton3:SetWidth(150);
      QTR_ToggleButton3:SetHeight(20);
      QTR_ToggleButton3:SetText("Quest ID=?");
      QTR_ToggleButton3:Show();
      QTR_ToggleButton3:ClearAllPoints();
      QTR_ToggleButton3:SetPoint("TOPLEFT", QuestGuru, "TOPLEFT", 330, -33);
      QTR_ToggleButton3:SetScript("OnClick", QTR_ON_OFF);
      -- otworzono QuestLog w QuestGuru
      QuestGuru:HookScript("OnShow",function() QTR_QuestLogOpen() end);
      -- kliknięto na nazwę questu w QuestLogu
      QuestGuru:HookScript("OnUpdate", function() QTR_QuestLogOpen() end);
   end
   
   if (ImmersionFrame ~= nil ) then
      -- przycisk z nr ID questu
      QTR_ToggleButton4 = CreateFrame("Button",nil, ImmersionFrame.TalkBox, "UIPanelButtonTemplate");
      QTR_ToggleButton4:SetWidth(150);
      QTR_ToggleButton4:SetHeight(20);
      QTR_ToggleButton4:SetText("Quest ID=?");
      QTR_ToggleButton4:Show();
      QTR_ToggleButton4:ClearAllPoints();
      QTR_ToggleButton4:SetPoint("TOPLEFT", ImmersionFrame.TalkBox, "TOPRIGHT", -200, -116);
      -- otworzono okno dodatku Immersion
      ImmersionFrame.TalkBox:HookScript("OnShow",function() QTR_delayed3() end);
   end
   
end



function QTR_ON_OFF()
   if (curr_trans=="1") then
      curr_trans="0";
      QTR_Translate_Off(1);
   else   
      curr_trans="1";
      QTR_Translate_On(1);
   end
end



-- Zmienne programowe zapisane na stałe na komputerze
function QuestTranslator_CheckVars()
  if (not QTR_PS) then
     QTR_PS = {};
  end
  if (not QTR_PC) then
     QTR_PC = {};
  end
  if (not QTR_SAVED) then
     QTR_SAVED = {};
  end
  -- inicjalizacja: tłumaczenia włączone
  if (not QTR_PS["active"]) then
     QTR_PS["active"] = "1";
  end
  -- inicjalizacja: tłumaczenie tytułu questu włączone
  if (not QTR_PS["transtitle"] ) then
     QTR_PS["transtitle"] = "0";   
  end
  -- zmienna specjalna dostępności funkcji GetQuestID 
  if ( QTR_PS["isGetQuestID"] ) then
     isGetQuestID=QTR_PS["isGetQuestID"];
  end;
  -- okresowe wyświetlanie reklam o dodatku 
  if (not QTR_PS["reklama"] ) then
     QTR_PS["reklama"] = "0";
     QTR_PS["period"] = 20;
     QTR_PS["text1"] = "0";
     QTR_PS["text2"] = "1";
     QTR_PS["channel"] = "0";
  end;
  if (not QTR_PS["other1"] ) then
     QTR_PS["other1"] = "1";
  end;
  if (not QTR_PS["other2"] ) then
     QTR_PS["other2"] = "1";
  end;
  if (not QTR_PS["channel"] ) then
     QTR_PS["channel"] = "0";
  end;
end



-- Sprawdza dostępność funkcji specjalnej Wow'a: GetQuestID()
function DetectEmuServer()
  QTR_PS["isGetQuestID"]="0";
  isGetQuestID="0";
  -- funkcja GetQuestID() występuje tylko na serwerach Blizzarda
  if ( GetQuestID() ) then
     QTR_PS["isGetQuestID"]="1";
     isGetQuestID="1";
  end
end



-- Obsługa komend slash
function QTR_SlashCommand(msg)
   if (msg=="on" or msg=="ON") then
      if (QTR_PS["active"]=="1") then
         print ("QTR - tłumaczenie są włączone.");
      else
         print ("|cffffff00QTR - włączam tłumaczenie.");
         QTR_PS["active"] = "1";
         QTR_ToggleButton0:Enable();
         QTR_ToggleButton1:Enable();
         QTR_ToggleButton2:Enable();
         if (QuestGuru ~= nil ) then
            QTR_ToggleButton3:Enable();
         end
         if (ImmersionFrame ~= nil ) then
            QTR_ToggleButton4:Enable();
         end
         QTR_Translate_On(1);
      end
   elseif (msg=="off" or msg=="OFF") then
      if (QTR_PS["active"]=="0") then
         print ("QTR - tłumaczenia są wyłączone.");
      else
         print ("|cffffff00QTR - wyłączam tłumaczenia.");
         QTR_PS["active"] = "0";
         QTR_ToggleButton0:Disable();
         QTR_ToggleButton1:Disable();
         QTR_ToggleButton2:Disable();
         if (QuestGuru ~= nil ) then
            QTR_ToggleButton3:Disable();
         end
         if (ImmersionFrame ~= nil ) then
            QTR_ToggleButton4:Disable();
         end
         QTR_Translate_Off(1);
      end
   elseif (msg=="title on" or msg=="TITLE ON" or msg=="title 1") then
      if (QTR_PS["transtilte"]=="1") then
         print ("QTR - tłumaczenie tytułów jest włączone.");
      else
         print ("|cffffff00QTR - włączam tłumaczenie tytułów.");
         QTR_PS["transtitle"] = "1";
         QuestInfoTitleHeader:SetFont(QTR_Font1, 18);
      end
   elseif (msg=="title off" or msg=="TITLE OFF" or msg=="title 0") then
      if (QTR_PS["transtilte"]=="0") then
         print ("QTR - tłumaczenie tytułów jest wyłączone.");
      else
         print ("|cffffff00QTR - wyłączam tłumaczenie tytułów.");
         QTR_PS["transtitle"] = "0";
         QuestInfoTitleHeader:SetFont(Original_Font1, 18);
      end
   elseif (msg=="title" or msg=="TITLE") then
      if (QTR_PS["transtilte"]=="1") then
         print ("QTR - tłumaczenie tytułów jest włączone.");
      else
         print ("QTR - tłumaczenie tytułów jest wyłączone.");
      end
   elseif (msg=="") then
      InterfaceOptionsFrame_Show();
      InterfaceOptionsFrame_OpenToCategory(QuestTranslatorOptions);
   else
      print ("QTR - menu szybkich komend addonu:");
      print ("      /qtr on  - włącza tłumaczenia");
      print ("      /qtr off - wyłącza tłumaczenia");
      print ("      /qtr title on  - włącza tłumaczenie tytułu");
      print ("      /qtr title off - wyłącza tłumaczenie tytułu");
   end
   if (QTR_PS["reklama"]=="1") then
      QTR_SendReklama();
   end
end



function QuestTranslator_SetCheckButtonState()
  QuestTranslatorCheckButton0:SetChecked(QTR_PS["active"]=="1");
  QuestTranslatorCheckButton3:SetChecked(QTR_PS["transtitle"]=="1");
  QuestTranslatorCheckButton5:SetChecked(QTR_PS["reklama"]=="1");
  QuestTranslatorCheckText1:SetChecked(QTR_PS["text1"]=="1");
  QuestTranslatorCheckText2:SetChecked(QTR_PS["text2"]=="1");
  QuestTranslatorCheckOther1:SetChecked(QTR_PS["other1"]=="1");
  QuestTranslatorCheckOther2:SetChecked(QTR_PS["other2"]=="1");
  QuestTranslatorEditBox:SetText(QTR_PS["channel"]);
end



function QuestTranslator_BlizzardOptions()
  -- Create main frame for information text
  local QuestTranslatorOptions = CreateFrame("FRAME", "QuestTranslatorOptions");
--  QuestTranslatorOptions:SetScript("OnShow", function(self) QuestTranslator_SetCheckButtonState() end);
  QuestTranslatorOptions.name = "QuestTranslator";
  QuestTranslatorOptions.refresh = function (self) QuestTranslator_SetCheckButtonState() end;
  InterfaceOptions_AddCategory(QuestTranslatorOptions);

  local QuestTranslatorOptionsHeader = QuestTranslatorOptions:CreateFontString(nil, "ARTWORK");
  QuestTranslatorOptionsHeader:SetFontObject(GameFontNormalLarge);
  QuestTranslatorOptionsHeader:SetJustifyH("LEFT"); 
  QuestTranslatorOptionsHeader:SetJustifyV("TOP");
  QuestTranslatorOptionsHeader:ClearAllPoints();
  QuestTranslatorOptionsHeader:SetPoint("TOPLEFT", 16, -16);
  QuestTranslatorOptionsHeader:SetText("QuestTranslator, ver. "..QTR_version.." "..QTR_lang.." ("..QTR_base..") by Platine © 2010-2017");

  local QuestTranslatorCheckButton0 = CreateFrame("CheckButton", "QuestTranslatorCheckButton0", QuestTranslatorOptions, "OptionsCheckButtonTemplate");
  QuestTranslatorCheckButton0:SetPoint("TOPLEFT", QuestTranslatorOptionsHeader, "BOTTOMLEFT", 0, -20);
  QuestTranslatorCheckButton0:SetScript("OnClick", function(self) if (QTR_PS["active"]=="1") then QTR_PS["active"]="0" else QTR_PS["active"]="1" end; end);
  QuestTranslatorCheckButton0Text:SetFont(QTR_Font2, 13);
  QuestTranslatorCheckButton0Text:SetText(QTR_Interface.active);

  local QuestTranslatorOptionsMode1 = QuestTranslatorOptions:CreateFontString(nil, "ARTWORK");
  QuestTranslatorOptionsMode1:SetFontObject(GameFontWhite);
  QuestTranslatorOptionsMode1:SetJustifyH("LEFT");
  QuestTranslatorOptionsMode1:SetJustifyV("TOP");
  QuestTranslatorOptionsMode1:ClearAllPoints();
  QuestTranslatorOptionsMode1:SetPoint("TOPLEFT", QuestTranslatorCheckButton0, "BOTTOMLEFT", 30, -20);
  QuestTranslatorOptionsMode1:SetFont(QTR_Font2, 13);
  QuestTranslatorOptionsMode1:SetText(QTR_Interface.options1);
  
  local QuestTranslatorCheckButton3 = CreateFrame("CheckButton", "QuestTranslatorCheckButton3", QuestTranslatorOptions, "OptionsCheckButtonTemplate");
  QuestTranslatorCheckButton3:SetPoint("TOPLEFT", QuestTranslatorOptionsMode1, "BOTTOMLEFT", 0, -5);
  QuestTranslatorCheckButton3:SetScript("OnClick", function(self) if (QTR_PS["transtitle"]=="0") then QTR_PS["transtitle"]="1" else QTR_PS["transtitle"]="0" end; end);
  QuestTranslatorCheckButton3Text:SetFont(QTR_Font2, 13);
  QuestTranslatorCheckButton3Text:SetText(QTR_Interface.transtitle);

  local QuestTranslatorCheckButton5 = CreateFrame("CheckButton", "QuestTranslatorCheckButton5", QuestTranslatorOptions, "OptionsCheckButtonTemplate");
  QuestTranslatorCheckButton5:SetPoint("TOPLEFT", QuestTranslatorCheckButton3, "BOTTOMLEFT", 0, -50);
  QuestTranslatorCheckButton5:SetScript("OnClick", function(self) if (QTR_PS["reklama"]=="0") then QTR_PS["reklama"]="1" else QTR_PS["reklama"]="0" end; end);
  QuestTranslatorCheckButton5Text:SetFont(QTR_Font2, 13);
  QuestTranslatorCheckButton5Text:SetText(QTR_Reklama.ON);

  local QuestTranslatorEditBox = CreateFrame("EditBox", "QuestTranslatorEditBox", QuestTranslatorOptions, "InputBoxTemplate");
  QuestTranslatorEditBox:SetPoint("TOPLEFT", QuestTranslatorCheckButton5Text, "TOPRIGHT", 10, 3);
  QuestTranslatorEditBox:SetHeight(20);
  QuestTranslatorEditBox:SetWidth(20);
  QuestTranslatorEditBox:SetAutoFocus(false) 
  QuestTranslatorEditBox:SetText(QTR_PS["channel"]);
  QuestTranslatorEditBox:SetCursorPosition(0);
  QuestTranslatorEditBox:SetScript("OnTextChanged", function(self) if (strlen(QuestTranslatorEditBox:GetText())>0) then QTR_PS["channel"]=QuestTranslatorEditBox:GetText() end; end);

  local QuestTranslatorChannelsFrame = CreateFrame("frame", "QuestTranslatorChannelsFrame", QuestTranslatorOptions, "UIDropDownMenuTemplate")
  QuestTranslatorChannelsFrame:SetPoint("TOPLEFT", QuestTranslatorEditBox, "TOPRIGHT", 40, 3);
  UIDropDownMenu_SetText(QuestTranslatorChannelsFrame, "Dostepne kanały:");
  QuestTranslatorChannelsFrame.onClick = function(self, arg1, arg2, checked) QuestTranslatorEditBox:SetText(arg1); end
  QuestTranslatorChannelsFrame.initialize = function(self, level)
	  local info = UIDropDownMenu_CreateInfo();
     info.text = "0: LocalArea SAY";
     info.value= "0";
     info.func = self.onClick;
     info.arg1 = "0";
     info.arg2 = "LocalArea SAY";
     UIDropDownMenu_AddButton(info, level);
     local ind1 = "0";
     for ind,nam in ipairs({GetChannelList()}) do
        if (strlen(nam)==1) then
           ind1 = nam;      -- channel number     
        else
           info.text = ind1 .. ": " .. nam;
           info.value= ind1;
           info.func = self.onClick;
           info.arg1 = ind1;
           info.arg2 = nam;
           UIDropDownMenu_AddButton(info, level);
	     end
     end
  end   
  
  local QuestTranslatorPeriodText = QuestTranslatorOptions:CreateFontString(nil, "ARTWORK");
  QuestTranslatorPeriodText:SetFontObject(GameFontWhite);
  QuestTranslatorPeriodText:SetJustifyH("LEFT");
  QuestTranslatorPeriodText:SetJustifyV("TOP");
  QuestTranslatorPeriodText:ClearAllPoints();
  QuestTranslatorPeriodText:SetPoint("TOPLEFT", QuestTranslatorCheckButton5, "BOTTOMLEFT", 30, -10);
  QuestTranslatorPeriodText:SetFont(QTR_Font2, 13);
  QuestTranslatorPeriodText:SetText(QTR_Reklama.PERIOD);
  
  local QTR_slider = CreateFrame("Slider","MyAddonSlider",QuestTranslatorOptions,'OptionsSliderTemplate');
  QTR_slider:ClearAllPoints();
  QTR_slider:SetPoint("TOPLEFT",QuestTranslatorPeriodText, "BOTTOMLEFT", 80, -30);
  getglobal(QTR_slider:GetName() .. 'Low'):SetText('15 min.');
  getglobal(QTR_slider:GetName() .. 'High'):SetText('90 min.');
  getglobal(QTR_slider:GetName() .. 'Text'):SetText('20 min.');
  QTR_slider:SetMinMaxValues(15, 90);
  QTR_slider:SetValue(QTR_PS["period"]);
  getglobal(QTR_slider:GetName() .. 'Text'):SetText(QTR_PS["period"] .. " min.");
  QTR_slider:SetValueStep(5);
  QTR_slider:SetScript("OnValueChanged", function(self)
      QTR_PS["period"] = math.floor(QTR_slider:GetValue()+0.5);
      getglobal(QTR_slider:GetName() .. 'Text'):SetText(QTR_PS["period"] .. " min.");
      end);

  local QuestTranslatorChoiceText = QuestTranslatorOptions:CreateFontString(nil, "ARTWORK");
  QuestTranslatorChoiceText:SetFontObject(GameFontWhite);
  QuestTranslatorChoiceText:SetJustifyH("LEFT");
  QuestTranslatorChoiceText:SetJustifyV("TOP");
  QuestTranslatorChoiceText:ClearAllPoints();
  QuestTranslatorChoiceText:SetPoint("TOPLEFT", QuestTranslatorPeriodText, "BOTTOMLEFT", 0, -80);
  QuestTranslatorChoiceText:SetFont(QTR_Font2, 13);
  QuestTranslatorChoiceText:SetText(QTR_Reklama.CHOICE);
  
  local QuestTranslatorCheckText1 = CreateFrame("CheckButton", "QuestTranslatorCheckText1", QuestTranslatorOptions, "OptionsCheckButtonTemplate");
  QuestTranslatorCheckText1:SetPoint("TOPLEFT", QuestTranslatorChoiceText, "BOTTOMLEFT", -50, -20);
  QuestTranslatorCheckText1:SetScript("OnClick", function(self) if (QTR_PS["text1"]=="0") then QTR_PS["text1"]="1" else QTR_PS["text1"]="0" end; end);
  QuestTranslatorCheckText1Text:SetFont(QTR_Font2, 13);
  QuestTranslatorCheckText1Text:SetText(QTR_Reklama.TEXT1);

  local QuestTranslatorCheckText2 = CreateFrame("CheckButton", "QuestTranslatorCheckText2", QuestTranslatorOptions, "OptionsCheckButtonTemplate");
  QuestTranslatorCheckText2:SetPoint("TOPLEFT", QuestTranslatorCheckText1, "BOTTOMLEFT", 0, -10);
  QuestTranslatorCheckText2:SetScript("OnClick", function(self) if (QTR_PS["text2"]=="0") then QTR_PS["text2"]="1" else QTR_PS["text2"]="0" end; end);
  QuestTranslatorCheckText2Text:SetFont(QTR_Font2, 13);
  QuestTranslatorCheckText2Text:SetText(QTR_Reklama.TEXT2);
  
  local QuestTranslatorIntegration0 = QuestTranslatorOptions:CreateFontString(nil, "ARTWORK");
  QuestTranslatorIntegration0:SetFontObject(GameFontWhite);
  QuestTranslatorIntegration0:SetJustifyH("LEFT");
  QuestTranslatorIntegration0:SetJustifyV("TOP");
  QuestTranslatorIntegration0:ClearAllPoints();
  QuestTranslatorIntegration0:SetPoint("TOPLEFT", QuestTranslatorCheckText2, "BOTTOMLEFT", 0, -20);
  QuestTranslatorIntegration0:SetFont(QTR_Font2, 13);
  QuestTranslatorIntegration0:SetText("Integracja z innymi addonami:");
  
  local QuestTranslatorIntegration1 = QuestTranslatorOptions:CreateFontString(nil, "ARTWORK");
  QuestTranslatorIntegration1:SetFontObject(GameFontNormal);
  QuestTranslatorIntegration1:SetJustifyH("LEFT");
  QuestTranslatorIntegration1:SetJustifyV("TOP");
  QuestTranslatorIntegration1:ClearAllPoints();
  QuestTranslatorIntegration1:SetPoint("TOPLEFT", QuestTranslatorIntegration0, "TOPRIGHT", 15, 0);
  QuestTranslatorIntegration1:SetFont(QTR_Font2, 13);
  QuestTranslatorIntegration1:SetText("QuestGuru,  Immersion");

  local QuestTranslatorCheckOther1 = CreateFrame("CheckButton", "QuestTranslatorCheckOther1", QuestTranslatorOptions, "OptionsCheckButtonTemplate");
  QuestTranslatorCheckOther1:SetPoint("TOPLEFT", QuestTranslatorIntegration1, "BOTTOMLEFT", -10, -20);
  QuestTranslatorCheckOther1:SetScript("OnClick", function(self) if (QTR_PS["other1"]=="0") then QTR_PS["other1"]="1" else QTR_PS["other1"]="0" end; end);
  QuestTranslatorCheckOther1Text:SetFont(QTR_Font2, 13);
  if (QuestGuru ~= nil ) then
     QuestTranslatorCheckOther1Text:SetText(QTR_Reklama.OTHER1..QTR_Reklama.ACTIV1);
  else
     QuestTranslatorCheckOther1Text:SetText(QTR_Reklama.OTHER1..QTR_Reklama.ACTIV2);
  end

  local QuestTranslatorCheckOther2 = CreateFrame("CheckButton", "QuestTranslatorCheckOther2", QuestTranslatorOptions, "OptionsCheckButtonTemplate");
  QuestTranslatorCheckOther2:SetPoint("TOPLEFT", QuestTranslatorCheckOther1, "BOTTOMLEFT", 0, -10);
  QuestTranslatorCheckOther2:SetScript("OnClick", function(self) if (QTR_PS["other2"]=="0") then QTR_PS["other2"]="1" else QTR_PS["other2"]="0" end; end);
  QuestTranslatorCheckOther2Text:SetFont(QTR_Font2, 13);
  if (ImmersionFrame ~= nil ) then
     QuestTranslatorCheckOther2Text:SetText(QTR_Reklama.OTHER2..QTR_Reklama.ACTIV1);
  else
     QuestTranslatorCheckOther2Text:SetText(QTR_Reklama.OTHER2..QTR_Reklama.ACTIV2);
  end
  
--  if (ImmersionFrame ~= nil ) then
--     local QTRslider = CreateFrame("Slider", "QTRslider", QuestTranslatorOptions, "OptionsSliderTemplate");
--     QTRslider:SetPoint("TOPLEFT", QuestTranslatorIntegration0, "BOTTOMLEFT", 0, -40);
--     QTRslider:SetMinMaxValues(0.5, 3.0);
--     QTRslider.minValue, QTRslider.maxValue = QTRslider:GetMinMaxValues();
--     QTRslider.Low:SetText(QTRslider.minValue.." sek");
--     QTRslider.High:SetText(QTRslider.maxValue.." sek");
--     getglobal(QTRslider:GetName() .. 'Text'):SetText('Opóźnienie Immersion');
--     getglobal(QTRslider:GetName() .. 'Text'):SetFont(QTR_Font2, 13);
--     QTRslider:SetValue(QTR_PS["delayImmersion"]);
--     QTRslider:SetValueStep(0.1);
--     QTRslider:SetScript("OnValueChanged", function(self,event,arg1) 
--                                           QTR_PS["delayImmersion"]=string.format("%.1f",event); 
--                                           QTRsliderVal:SetText(QTR_PS["delayImmersion"]);
--                                           end);
--     QTRsliderVal = QuestTranslatorOptions:CreateFontString(nil, "ARTWORK");
--     QTRsliderVal:SetFontObject(GameFontNormal);
--     QTRsliderVal:SetJustifyH("CENTER");
--     QTRsliderVal:SetJustifyV("TOP");
--     QTRsliderVal:ClearAllPoints();
--     QTRsliderVal:SetPoint("CENTER", QTRslider, "CENTER", 0, -12);
--     QTRsliderVal:SetFont(QTR_Font2, 13);
--     QTRsliderVal:SetText(QTR_PS["delayImmersion"]);   
--     end
  
end



-- Określa aktualny numer ID questu z różnych metod
function QTR_GetQuestID()
   quest_ID = QuestMapFrame.DetailsFrame.questID;
   
   if (quest_ID==nil) then
      quest_ID = QuestLogPopupDetailFrame.questID;
   end
   
   if (quest_ID==nil) then
      if ((QuestGuru ~= nil) and (QuestGuru:IsVisible())) then
         local questTitle, level, questTag, isHeader, isCollapsed, isComplete, isDaily, questID = GetQuestLogTitle(GetQuestLogSelection());
         quest_ID = questID;
      end
   end
   
   if(quest_ID==nil) then
      if ((ImmersionFrame ~= nil) and (ImmersionFrame:IsVisible())) then
         local nameOrig=ImmersionFrame.TalkBox.NameFrame.Name:GetText();
         local i = 1;
         while GetQuestLogTitle(i) do    -- przeglądaj wszystkie questy w QuestLogu
            local questTitle, level, questTag, isHeader, isCollapsed, isComplete, isDaily, questID = GetQuestLogTitle(i);
            if (questTitle==nameOrig) then
               quest_ID = questID;
               break;
            end
            i = i + 1;
         end         
      end
   end   
   
   if (quest_ID==nil) then
      if ( isGetQuestID=="1" ) then
         quest_ID = GetQuestID();
      end
   end         

   if (quest_ID==nil) then
      quest_ID=0;
   end   
   
   return (quest_ID);
end



-- Wywoływane przy przechwytywanych zdarzeniach
function QTR_OnEvent(self, event, name, ...)
   if (event=="ADDON_LOADED" and name=="QuestTranslator") then
      SlashCmdList["QUESTTRANSLATOR"] = function(msg) QTR_SlashCommand(msg); end
      SLASH_QUESTTRANSLATOR1 = "/questtranslator";
      SLASH_QUESTTRANSLATOR2 = "/qtr";
      QuestTranslator_CheckVars();
      -- twórz interface Options w Blizzard-Interface-Addons
      QuestTranslator_BlizzardOptions();
      print ("|cffffff00QuestTranslator ver. "..QTR_version.." "..QTR_lang.." - "..QuestTranslator_Messages.loaded);
      QTR:UnregisterEvent("ADDON_LOADED");
      QTR.ADDON_LOADED = nil;
      if (not isGetQuestID) then
         DetectEmuServer();
      end
      if (QTR_PS["active"]=="1") then
         QTR_Translate_On(1);
         QTR_ToggleButton0:Enable();
         QTR_ToggleButton1:Enable();
         QTR_ToggleButton2:Enable();
         if (QuestGuru ~= nil ) then
            QTR_ToggleButton3:Enable();
         end
         if (ImmersionFrame ~= nil ) then
            QTR_ToggleButton4:Enable();
         end
      else
         QTR_ToggleButton0:Disable();
         QTR_ToggleButton1:Disable();
         QTR_ToggleButton2:Disable();
         if (QuestGuru ~= nil ) then
            QTR_ToggleButton3:Disable();
         end
         if (ImmersionFrame ~= nil ) then
            QTR_ToggleButton4:Disable();
         end
      end
   elseif (event=="QUEST_DETAIL" or event=="QUEST_PROGRESS" or event=="QUEST_COMPLETE") then
      if ( QuestFrame:IsVisible() ) then
         QTR_quest_EN.id = 0;
         QTR_quest_LG.id = 0;
         q_ID = QTR_GetQuestID();
         str_ID=tostring(q_ID);
         if ( QTR_PS["active"]=="1" ) then	-- tłumaczenia włączone
            curr_trans = "1";
            if ( QuestTranslator_QuestData[str_ID] ) then
               -- wyświetlaj tylko, gdy istnieje tłumaczenie
               QTR_quest_EN.id = q_ID;
               QTR_quest_LG.id = q_ID;
               QTR_quest_EN.title = GetTitleText();
               QTR_quest_LG.title = QuestTranslator_QuestData[str_ID]["Title"];
               QTR_quest_EN.details = GetQuestText();
               QTR_quest_LG.details = QTR_ExpandUnitInfo(QuestTranslator_QuestData[str_ID]["Description"]);
               QTR_quest_EN.objectives = GetObjectiveText();
               QTR_quest_LG.objectives = QTR_ExpandUnitInfo(QuestTranslator_QuestData[str_ID]["Objectives"]);
               QTR_quest_EN.progress = GetProgressText();
               QTR_quest_LG.progress = QTR_ExpandUnitInfo(QuestTranslator_QuestData[str_ID]["Progress"]);
               QTR_quest_EN.completion = GetRewardText();
               QTR_quest_LG.completion = QTR_ExpandUnitInfo(QuestTranslator_QuestData[str_ID]["Completion"]);
               if (event=="QUEST_DETAIL") then
                  QTR_quest_EN.itemchoose = QuestTranslator_MessOrig.itemchoose1;
                  QTR_quest_LG.itemchoose = QuestTranslator_Messages.itemchoose1;
                  QTR_quest_EN.itemreceive = QuestTranslator_MessOrig.itemreceiv1;
                  QTR_quest_LG.itemreceive = QuestTranslator_Messages.itemreceiv1;
               end
               if (event=="QUEST_COMPLETE") then
                  QTR_quest_EN.itemchoose = QuestTranslator_MessOrig.itemchoose2;
                  QTR_quest_LG.itemchoose = QuestTranslator_Messages.itemchoose2;
                  QTR_quest_EN.itemreceive = QuestTranslator_MessOrig.itemreceiv2;
                  QTR_quest_LG.itemreceive = QuestTranslator_Messages.itemreceiv2;
               end
               QTR_Translate_On(1);
            else	-- nie ma przetłumaczonego takiego questu
               QTR_ToggleButton0:SetText("Quest ID="..str_ID);
               QTR_Translate_On(0);
               if (event=="QUEST_DETAIL") then
                  QTR_SAVED[str_ID.." TITLE"]=GetTitleText();            -- save original title to future translation
                  QTR_SAVED[str_ID.." DESCRIPTION"]=GetQuestText();      -- save original text to future translation
                  QTR_SAVED[str_ID.." OBJECTIVE"]=GetObjectiveText();    -- save original text to future translation
               end
               if (event=="QUEST_PROGRESS") then
                  QTR_SAVED[str_ID.." PROGRESS"]=GetProgressText();      -- save original text to future translation
               end
               if (event=="QUEST_COMPLETE") then
                  QTR_SAVED[str_ID.." COMPLETE"]=GetRewardText();        -- save original text to future translation
               end
            end -- jest przetłumaczony quest w bazie
         else	-- tłumaczenia wyłączone
            if ( QuestTranslator_QuestData[str_ID] ) then	-- ale jest tłumaczenie w bazie
               QTR_ToggleButton0:SetText("Quest ID="..str_ID.." (EN)");
            else
               QTR_ToggleButton0:SetText("Quest ID="..str_ID);
            end
         end	-- tłumaczenia są włączone
      end	-- QuestFrame is Visible
   elseif (ImmersionFrame ~= nil and event=="QUEST_ACCEPTED") then
      QTR_delayed3();
   end
   if (QTR_PS["reklama"]=="1") then
      QTR_SendReklama();
   end
end



-- Otworzono okienko QuestLogPopupDetailFrame lub QuestMapDetailsScrollFrame lub QuestGuru lub Immersion
function QTR_QuestLogOpen()
   if (QuestGuru ~= nil) then
      if (QTR_PS["other1"]=="0") then       -- jest aktywny QuestGuru, ale nie zezwolono na tłumaczenie
         QTR_ToggleButton3:Hide();
         return
      else   
         QTR_ToggleButton3:Show();
      end   
   end
   if (ImmersionFrame ~= nil) then
      if (QTR_PS["other2"]=="0") then       -- jest aktywny Immersion, ale nie zezwolono na tłumaczenie
         QTR_ToggleButton4:Hide();
         return
      else
         QTR_ToggleButton4:Show();
      end      
   end
   QTR_quest_EN.id = 0;
   QTR_quest_LG.id = 0;
   if (ImmersionFrame ~= nil ) then
      QTR_ToggleButton4:SetScript("OnClick", nil);
   end
   q_ID = QTR_GetQuestID();
   str_ID = tostring(q_ID);
   if ( QTR_PS["active"]=="1" ) then	-- tłumaczenia włączone
      curr_trans = "1";
      if ( QuestTranslator_QuestData[str_ID] ) then
         -- wyświetlaj tylko, gdy istnieje tłumaczenie
         QTR_quest_EN.id = q_ID;
         QTR_quest_LG.id = q_ID;
         QTR_quest_LG.title = QTR_ExpandUnitInfo(QuestTranslator_QuestData[str_ID]["Title"]);
         if (QTR_quest_LG.title ~= QuestInfoTitleHeader:GetText()) then
            QTR_quest_EN.title = QuestInfoTitleHeader:GetText();
         end         
         QTR_quest_LG.details = QTR_ExpandUnitInfo(QuestTranslator_QuestData[str_ID]["Description"]);
         if (QTR_quest_LG.details ~= QuestInfoDescriptionText:GetText()) then
            QTR_quest_EN.details = QuestInfoDescriptionText:GetText();
         end
         QTR_quest_LG.objectives = QTR_ExpandUnitInfo(QuestTranslator_QuestData[str_ID]["Objectives"]);
         if (QTR_quest_LG.objectives ~= QuestInfoObjectivesText:GetText()) then
            QTR_quest_EN.objectives = QuestInfoObjectivesText:GetText();
         end   
         QTR_quest_LG.itemchoose = QuestTranslator_Messages.itemchoose1;
         QTR_quest_EN.itemchoose = QuestTranslator_MessOrig.itemchoose1;
         QTR_quest_LG.itemreceive = QuestTranslator_Messages.itemreceiv1;
         QTR_quest_EN.itemreceive = QuestTranslator_MessOrig.itemreceiv1;
--         if ( not QTR_wait(0.5,QTR_Translate_On(1)) ) then
            QTR_Translate_On(1);
--         end   
      else	-- nie ma przetłumaczonego takiego questu
         QTR_ToggleButton1:SetText("Quest ID="..str_ID);
         QTR_ToggleButton2:SetText("Quest ID="..str_ID);
         if (QuestGuru ~= nil ) then
            QTR_ToggleButton3:SetText("Quest ID="..str_ID);
         end
         if (ImmersionFrame ~= nil ) then
            if (q_ID==0) then
               if (ImmersionFrame.TitleButtons:IsVisible()) then
                  QTR_ToggleButton4:SetText("wybierz wpierw quest");
               else
                  QTR_ToggleButton4:SetText("Quest ID reload");
                  QTR_ToggleButton4:SetScript("OnClick", QTR_ImmersionLoad);
               end
            else
               QTR_ToggleButton4:SetText("Quest ID="..str_ID);
            end
         end
         QTR_Translate_On(0);
      end -- jest przetłumaczony quest w bazie
   else	-- tłumaczenia wyłączone
      if ( QuestTranslator_QuestData[str_ID] ) then	-- ale jest tłumaczenie w bazie
         QTR_ToggleButton1:SetText("Quest ID="..str_ID.." (EN)");
         QTR_ToggleButton2:SetText("Quest ID="..str_ID.." (EN)");
         if (QuestGuru ~= nil ) then
            QTR_ToggleButton3:SetText("Quest ID="..str_ID.." (EN)");
         end
         if (ImmersionFrame ~= nil ) then
            QTR_ToggleButton4:SetText("Quest ID="..str_ID.." (EN)");
         end
      else
         QTR_ToggleButton1:SetText("Quest ID="..str_ID);
         QTR_ToggleButton2:SetText("Quest ID="..str_ID);
         if (QuestGuru ~= nil ) then
            QTR_ToggleButton3:SetText("Quest ID="..str_ID);
         end
         if (ImmersionFrame ~= nil ) then
            QTR_ToggleButton4:SetText("Quest ID="..str_ID);
         end
      end
   end	-- tłumaczenia są włączone
   if (QTR_PS["reklama"]=="1") then
      QTR_SendReklama();
   end
end



-- wyświetla tłumaczenie
function QTR_Translate_On(typ)
   if (QTR_PS["transtitle"]=="1") then    -- wyświetl przetłumaczony tytuł
      QuestInfoTitleHeader:SetFont(QTR_Font1, 18);
      QuestProgressTitleText:SetFont(QTR_Font1, 18);
   end
   QuestInfoObjectivesHeader:SetFont(QTR_Font1, 18);
   QuestInfoObjectivesHeader:SetText(QuestTranslator_Messages.objectives);
   QuestInfoRewardsFrame.Header:SetFont(QTR_Font1, 18);
   QuestInfoRewardsFrame.Header:SetText(QuestTranslator_Messages.rewards);
   QuestInfoDescriptionHeader:SetFont(QTR_Font1, 18);
   QuestInfoDescriptionHeader:SetText(QuestTranslator_Messages.details);
   QuestProgressRequiredItemsText:SetFont(QTR_Font1, 18);
   QuestProgressRequiredItemsText:SetText(QuestTranslator_Messages.reqitems);
   QuestInfoDescriptionText:SetFont(QTR_Font2, 13);
   QuestInfoObjectivesText:SetFont(QTR_Font2, 13);
   QuestProgressText:SetFont(QTR_Font2, 13);
   QuestInfoRewardText:SetFont(QTR_Font2, 13);
   QuestInfoRewardsFrame.ItemChooseText:SetFont(QTR_Font2, 13);
   QuestInfoRewardsFrame.ItemReceiveText:SetFont(QTR_Font2, 13);
   QuestInfoSpellObjectiveLearnLabel:SetFont(QTR_Font2, 13);
   QuestInfoSpellObjectiveLearnLabel:SetText(QuestTranslator_Messages.learnspell);
   QuestInfoXPFrame.ReceiveText:SetFont(QTR_Font2, 13);
   QuestInfoXPFrame.ReceiveText:SetText(QuestTranslator_Messages.experience);
   if (typ==1) then			-- pełne przełączenie (jest tłumaczenie)
      QuestInfoRewardsFrame.ItemChooseText:SetText(QuestTranslator_Messages.itemchoose1);
      QuestInfoRewardsFrame.ItemReceiveText:SetText(QuestTranslator_Messages.itemreceiv1);
      numer_ID = QTR_GetQuestID();
      if (numer_ID>0 and numer_ID==QTR_quest_LG.id) then	-- przywróć przetłumaczoną wersję napisów
         QTR_ToggleButton0:SetText("Quest ID="..QTR_quest_LG.id.." ("..QTR_lang..")");
         QTR_ToggleButton1:SetText("Quest ID="..QTR_quest_LG.id.." ("..QTR_lang..")");
         QTR_ToggleButton2:SetText("Quest ID="..QTR_quest_LG.id.." ("..QTR_lang..")");
         if (QuestGuru ~= nil ) then
            QTR_ToggleButton3:SetText("Quest ID="..QTR_quest_LG.id.." ("..QTR_lang..")");
         end
         if (ImmersionFrame ~= nil ) then
            QTR_ToggleButton4:SetText("Quest ID="..QTR_quest_LG.id.." ("..QTR_lang..")");
            if (not QTR_wait(0.2,QTR_Immersion)) then    -- wywołaj podmienianie danych po 0.2 sek
               -- nothing
            end
         end
         if (QTR_PS["transtitle"]=="1") then
            QuestInfoTitleHeader:SetText(QTR_quest_LG.title);
         end
         QuestProgressTitleText:SetText(QTR_quest_LG.title);
         QuestInfoDescriptionText:SetText(QTR_quest_LG.details);
         QuestInfoObjectivesText:SetText(QTR_quest_LG.objectives);
         QuestProgressText:SetText(QTR_quest_LG.progress);
         QuestInfoRewardText:SetText(QTR_quest_LG.completion);
         QuestInfoRewardsFrame.ItemChooseText:SetText(QTR_quest_LG.itemchoose);
         QuestInfoRewardsFrame.ItemReceiveText:SetText(QTR_quest_LG.itemreceive);
      end
      if (MapQuestInfoRewardsFrame.ItemReceiveText:IsVisible() ) then
         if (not QTR_wait(2,QTR_delayed2)) then
            -- podmiana tekstu z opóźnieniem 2 sek
         end
      end
   else
      if (curr_trans == "1") then
         QuestInfoRewardsFrame.ItemChooseText:SetText(QuestTranslator_Messages.itemchoose1);
         QuestInfoRewardsFrame.ItemReceiveText:SetText(QuestTranslator_Messages.itemreceiv1);
         if ((ImmersionFrame ~= nil ) and (ImmersionFrame.TalkBox:IsVisible() )) then
            if (not QTR_wait(0.2,QTR_delayed1)) then
               -- podmiana tekstu z opóźnieniem 0.2 sek
            end
         end
         if (MapQuestInfoRewardsFrame.ItemReceiveText:IsVisible() ) then
            if (not QTR_wait(2,QTR_delayed2)) then
               -- podmiana tekstu z opóźnieniem 2 sek
            end
         end
      end
   end
end



-- wyświetla oryginalny tekst
function QTR_Translate_Off(typ)
   QuestInfoTitleHeader:SetFont(Original_Font1, 18);
   QuestProgressTitleText:SetFont(Original_Font1, 18);
   QuestInfoObjectivesHeader:SetFont(Original_Font1, 18);
   QuestInfoObjectivesHeader:SetText(QuestTranslator_MessOrig.objectives);
   QuestInfoRewardsFrame.Header:SetFont(Original_Font1, 18);
   QuestInfoRewardsFrame.Header:SetText(QuestTranslator_MessOrig.rewards);
   QuestInfoDescriptionHeader:SetFont(Original_Font1, 18);
   QuestInfoDescriptionHeader:SetText(QuestTranslator_MessOrig.details);
   QuestProgressRequiredItemsText:SetFont(Original_Font1, 18);
   QuestProgressRequiredItemsText:SetText(QuestTranslator_MessOrig.reqitems);
   QuestInfoDescriptionText:SetFont(Original_Font2, 13);
   QuestInfoObjectivesText:SetFont(Original_Font2, 13);
   QuestProgressText:SetFont(Original_Font2, 13);
   QuestInfoRewardText:SetFont(Original_Font2, 13);
   QuestInfoRewardsFrame.ItemChooseText:SetFont(Original_Font2, 13);
   QuestInfoRewardsFrame.ItemReceiveText:SetFont(Original_Font2, 13);
   MapQuestInfoRewardsFrame.ItemReceiveText:SetFont(Original_Font2, 13);
   QuestInfoSpellObjectiveLearnLabel:SetFont(Original_Font2, 13);
   QuestInfoSpellObjectiveLearnLabel:SetText(QuestTranslator_MessOrig.learnspell);
   QuestInfoXPFrame.ReceiveText:SetFont(Original_Font2, 13);
   QuestInfoXPFrame.ReceiveText:SetText(QuestTranslator_MessOrig.experience);
   if (typ==1) then			-- pełne przełączenie (jest tłumaczenie)
      QuestInfoRewardsFrame.ItemChooseText:SetText(QuestTranslator_MessOrig.itemchoose1);
      QuestInfoRewardsFrame.ItemReceiveText:SetText(QuestTranslator_MessOrig.itemreceiv1);
      MapQuestInfoRewardsFrame.ItemReceiveText:SetText(QuestTranslator_MessOrig.itemreceiv1);
      numer_ID = QTR_GetQuestID();
      if (numer_ID>0 and numer_ID==QTR_quest_EN.id) then	-- przywróć oryginalną wersję napisów
         QTR_ToggleButton0:SetText("Quest ID="..QTR_quest_EN.id.." (EN)");
         QTR_ToggleButton1:SetText("Quest ID="..QTR_quest_EN.id.." (EN)");
         QTR_ToggleButton2:SetText("Quest ID="..QTR_quest_EN.id.." (EN)");
         if (QuestGuru ~= nil ) then
            QTR_ToggleButton3:SetText("Quest ID="..QTR_quest_EN.id.." (EN)");
         end
         if (ImmersionFrame ~= nil ) then
            QTR_ToggleButton4:SetText("Quest ID="..QTR_quest_EN.id.." (EN)");
            ImmersionContentFrame.RewardsFrame.XPFrame.ReceiveText:SetFont(Original_Font2, 13);
            ImmersionContentFrame.RewardsFrame.XPFrame.ReceiveText:SetText(QuestTranslator_MessOrig.experience);  -- "Doświadczenie"
            ImmersionContentFrame.ObjectivesHeader:SetFont(Original_Font1, 18);
            ImmersionContentFrame.ObjectivesHeader:SetText(QuestTranslator_MessOrig.objectives);  -- "Zadanie"
            ImmersionContentFrame.RewardsFrame.Header:SetFont(Original_Font1, 18);
            ImmersionContentFrame.RewardsFrame.Header:SetText(QuestTranslator_MessOrig.rewards);  -- "Nagroda"
            ImmersionContentFrame.RewardsFrame.ItemReceiveText:SetFont(Original_Font2, 13);
            ImmersionContentFrame.RewardsFrame.ItemReceiveText:SetText(QuestTranslator_MessOrig.itemreceiv1); -- "Otrzymasz w nagrodę:"
         end
         QuestInfoTitleHeader:SetText(QTR_quest_EN.title);
         QuestProgressTitleText:SetText(QTR_quest_EN.title);
         QuestInfoDescriptionText:SetText(QTR_quest_EN.details);
         QuestInfoObjectivesText:SetText(QTR_quest_EN.objectives);
         QuestProgressText:SetText(QTR_quest_EN.progress);
         QuestInfoRewardText:SetText(QTR_quest_EN.completion);
         QuestInfoRewardsFrame.ItemChooseText:SetText(QTR_quest_EN.itemchoose);
         QuestInfoRewardsFrame.ItemReceiveText:SetText(QTR_quest_EN.itemreceive);
      end
   end
end


function QTR_wait(delay, func, ...)
  if(type(delay)~="number" or type(func)~="function") then
    return false;
  end
  if(QTR_waitFrame == nil) then
    QTR_waitFrame = CreateFrame("Frame","QTR_WaitFrame", UIParent);
    QTR_waitFrame:SetScript("onUpdate",function (self,elapse)
      local count = #QTR_waitTable;
      local i = 1;
      while(i<=count) do
        local waitRecord = tremove(QTR_waitTable,i);
        local d = tremove(waitRecord,1);
        local f = tremove(waitRecord,1);
        local p = tremove(waitRecord,1);
        if(d>elapse) then
          tinsert(QTR_waitTable,i,{d-elapse,f,p});
          i = i + 1;
        else
          count = count - 1;
          f(unpack(p));
        end
      end
    end);
  end
  tinsert(QTR_waitTable,{delay,func,{...}});
  return true;
end


function QTR_SendReklama()
  local now = GetTime();
  if (last_time + QTR_PS["period"]*60 < now) then                  -- OK, czas wypisać reklamę
     if ((QTR_PS["text1"]=="1") and (QTR_PS["text2"]=="1")) then   -- oba teksty naprzemiennie
        if (last_text==2) then
           if (tonumber(QTR_PS["channel"])>0) then
              SendChatMessage(QTR_Reklama.TEXT1,"CHANNEL",nil,tonumber(QTR_PS["channel"]));
           else
              SendChatMessage(QTR_Reklama.TEXT1,"SAY");
           end
           last_text = 1;
        else
           if (tonumber(QTR_PS["channel"])>0) then
              SendChatMessage(QTR_Reklama.TEXT2,"CHANNEL",nil,tonumber(QTR_PS["channel"]));
           else
              SendChatMessage(QTR_Reklama.TEXT2,"SAY");
           end
           last_text = 2;
        end
     elseif (QTR_PS["text1"]=="1") then
        if (tonumber(QTR_PS["channel"])>0) then
           SendChatMessage(QTR_Reklama.TEXT1,"CHANNEL",nil,tonumber(QTR_PS["channel"]));
        else
           SendChatMessage(QTR_Reklama.TEXT1,"SAY");
        end        
        last_text = 1;
     elseif (QTR_PS["text2"]=="1") then
        if (tonumber(QTR_PS["channel"])>0) then
           SendChatMessage(QTR_Reklama.TEXT2,"CHANNEL",nil,tonumber(QTR_PS["channel"]));
        else
           SendChatMessage(QTR_Reklama.TEXT2,"SAY");
        end
        last_text = 2;
     end
     last_time = now;
  end   
end


function QTR_delayed1()     -- podmiana tekstu z opóźnieniem 1 sek
  ImmersionContentFrame.RewardsFrame.ItemReceiveText:SetFont(QTR_Font2, 13);     -- jest przywracana pierwotna nazwa i trzeba podmieniać za każdym razem
  ImmersionContentFrame.RewardsFrame.ItemReceiveText:SetText(QuestTranslator_Messages.itemreceiv1); -- "Otrzymasz w nagrodę:"
  ImmersionFrame.TalkBox.Elements.Progress.ReqText:SetFont(QTR_Font1, 18);
  ImmersionFrame.TalkBox.Elements.Progress.ReqText:SetText(QuestTranslator_Messages.reqitems);  -- "Wymagane itemy:"
end


function QTR_delayed2()     -- podmiana tekstu z opóźnieniem 2 sek
   MapQuestInfoRewardsFrame.ItemReceiveText:SetFont(QTR_Font2, 13);
   MapQuestInfoRewardsFrame.ItemReceiveText:SetText(QuestTranslator_Messages.itemreceiv1);
end


function QTR_delayed3()
   QTR_ToggleButton4:SetText("wybierz wpierw quest");
   if (not QTR_wait(1,QTR_delayed4)) then
   ---
   end
end


function QTR_delayed4()
   if (ImmersionFrame.TitleButtons:IsVisible()) then
      if (ImmersionFrame.TitleButtons.Buttons[1] ~= nil ) then
         ImmersionFrame.TitleButtons.Buttons[1]:HookScript("OnClick", function() QTR_ImmersionLoad() end);
      end
      if (ImmersionFrame.TitleButtons.Buttons[2] ~= nil ) then
         ImmersionFrame.TitleButtons.Buttons[2]:HookScript("OnClick", function() QTR_ImmersionLoad() end);
      end
      if (ImmersionFrame.TitleButtons.Buttons[3] ~= nil ) then
         ImmersionFrame.TitleButtons.Buttons[3]:HookScript("OnClick", function() QTR_ImmersionLoad() end);
      end   
      if (ImmersionFrame.TitleButtons.Buttons[4] ~= nil ) then
         ImmersionFrame.TitleButtons.Buttons[4]:HookScript("OnClick", function() QTR_ImmersionLoad() end);
      end
      if (ImmersionFrame.TitleButtons.Buttons[5] ~= nil ) then
         ImmersionFrame.TitleButtons.Buttons[5]:HookScript("OnClick", function() QTR_ImmersionLoad() end);
      end
   end
   QTR_QuestLogOpen()
end;      


function QTR_ImmersionLoad()     -- wywoływane po kliknięciu na nazwę questu z listy NPC
   if (not QTR_wait(1,QTR_QuestLogOpen)) then
   ---
   end
end;      


function QTR_ImmersionReload()     
   QTR_QuestLogOpen()
end;      


function QTR_Immersion()   -- wywoływanie z opóźnieniem 0.2 sek
  ImmersionContentFrame.RewardsFrame.ItemReceiveText:SetFont(QTR_Font2, 13);     -- jest przywracana pierwotna nazwa i trzeba podmieniać za każdym razem
  ImmersionContentFrame.RewardsFrame.ItemReceiveText:SetText(QuestTranslator_Messages.itemreceiv1); -- "Otrzymasz w nagrodę:"
  ImmersionFrame.TalkBox.Elements.Progress.ReqText:SetFont(QTR_Font1, 18);
  ImmersionFrame.TalkBox.Elements.Progress.ReqText:SetText(QuestTranslator_Messages.reqitems);  -- "Wymagane itemy:"
  ImmersionContentFrame.RewardsFrame.XPFrame.ReceiveText:SetFont(QTR_Font2, 13);
  ImmersionContentFrame.RewardsFrame.XPFrame.ReceiveText:SetText(QuestTranslator_Messages.experience);  -- "Doświadczenie"
  ImmersionContentFrame.ObjectivesHeader:SetFont(QTR_Font1, 18);
  ImmersionContentFrame.ObjectivesHeader:SetText(QuestTranslator_Messages.objectives);  -- "Zadanie"
  ImmersionContentFrame.RewardsFrame.Header:SetFont(QTR_Font1, 18);
  ImmersionContentFrame.RewardsFrame.Header:SetText(QuestTranslator_Messages.rewards);  -- "Nagroda"
  ImmersionContentFrame.ObjectivesText:SetFont(QTR_Font2, 14);
  ImmersionContentFrame.ObjectivesText:SetText(QTR_quest_LG.objectives);
  ImmersionFrame.TalkBox.NameFrame.Name:SetFont(QTR_Font1, 20);
  ImmersionFrame.TalkBox.NameFrame.Name:SetText(QTR_quest_LG.title);
  ImmersionFrame.TalkBox.TextFrame.Text:SetFont(QTR_Font2, 14);
  ImmersionFrame.TalkBox.TextFrame.Text:SetText(QTR_quest_LG.details);
end


-- podmieniaj specjane znaki w tekście
function QTR_ExpandUnitInfo(msg)
   msg = string.gsub(msg, "NEW_LINE", "\n");
   msg = string.gsub(msg, "YOUR_NAME", QTR_name);
   
   msg = string.gsub(msg, "YOUR_RACE YOUR_CLASS", "YOUR_RACE "..player_class.M);     -- Mianownik (kto, co?)
   msg = string.gsub(msg, "ym YOUR_RACE", "ym "..player_race.N);              -- Narzędnik (kim, czym?)
   msg = string.gsub(msg, " jesteś YOUR_RACE", " jesteś "..player_race.N);    -- Narzędnik (kim, czym?)
   msg = string.gsub(msg, ", YOUR_RACE", ", "..player_race.W);                -- Wołacz (o!) 
   if (string.sub(msg,1,9)=="YOUR_RACE") then                                 -- Zaczyna się zdanie od YOUR_RACE
      msg = player_race.W..string.sub(msg,10);                                -- Wołacz (niestety z małej
   end
   msg = string.gsub(msg, " z YOUR_RACE", " z "..player_race.D);              -- Dopełniacz (kogo, czego?) 
   msg = string.gsub(msg, "YOUR_RACE", player_race.M);                        -- Mianownik - pozostałe wystąpienia
   
   msg = string.gsub(msg, "ym YOUR_CLASS", "ym "..player_class.N);            -- Narzędnik (kim, czym?)
   msg = string.gsub(msg, "esteś YOUR_CLASS", "esteś "..player_class.N);      -- Narzędnik (kim, czym?)
   msg = string.gsub(msg, " z Ciebie YOUR_CLASS", " z Ciebie "..player_class.M);    -- Mianownik (kto, co?)
   msg = string.gsub(msg, " kolejny YOUR_CLASS do ", " kolejny "..player_class.M.." do ");   -- Mianownik (kto, co?)
   msg = string.gsub(msg, " taki YOUR_CLASS", " taki "..player_class.M);      -- Mianownik (kto, co?)
   msg = string.gsub(msg, "ako YOUR_CLASS", "ako "..player_class.M);          -- Mianownik (kto, co?)
   msg = string.gsub(msg, " co sprowadza YOUR_CLASS", " co sprowadza "..player_class.B);     -- Biernik (kogo, co?)
   msg = string.gsub(msg, " będę miał YOUR_CLASS", " będę miał "..player_class.B);  -- Biernik (kogo, co?)
   msg = string.gsub(msg, "ego YOUR_CLASS", "ego "..player_class.B);                -- Biernik (kogo, co?)
   msg = string.gsub(msg, "YOUR_CLASS taki jak ", player_class.B.." taki jak ");    -- Biernik (kogo, co?)
   msg = string.gsub(msg, " jak na YOUR_CLASS", " jak na "..player_class.B);        -- Biernik (kogo, co?)
   msg = string.gsub(msg, "YOUR_CLASS", player_class.W);                      -- Wołacz - pozostałe wystąpienia

   return msg;
end
